.686			
.MMX
.model flat, stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\masm32.inc

include \masm32\macros\macros.asm
include \masm32\macros\timers.asm

include \masm32\include\msvcrt.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib

includelib \masm32\lib\msvcrt.lib

Main        proto

QWtoASCII   proto
qwtoa       PROTO :DWORD
i64toa      proto :QWORD,:DWORD
DW2A        proto

.const

  sqwTest1      QWORD -9199999999444444444  ; worst case for IanB code
  sqwTest2      QWORD -9087654321987654321  ; no advantage
  sqwTest3      QWORD -1000000000999999999  ; best case for IanB code
  sqwTest4      QWORD -999999444444444      ; worst case for IanB code
  sqwTest5      QWORD -555555123456789      ; no advantage
  sqwTest6      QWORD -100000999999999      ; best case for IanB code

  sdwTest1      QWORD -1444444444           ; worst case for IanB code
  sdwTest2      QWORD -1234567890           ; no advantage
  sdwTest3      QWORD -1999999999           ; best case for IanB code
  sdwTest4      QWORD -44444                ; worst case for IanB code
  sdwTest5      QWORD -12345                ; no advantage
  sdwTest6      QWORD -99999                ; best case for IanB code
  sdwTest7      QWORD -1

.data

  LOOP_COUNT    EQU	1000000

  fMtStrinG     db "%ld",0
  SzWS          db "wsprintf conversion: ",0
  SzIB          db "SQWtoASCII - IanB:   ",0
  SzRF          db "qwtoa - Raymond F:   ",0
  SzCRT         db "MSVCRT _i64toa   :   ",0

  SzQTest1       db "QWTest 1 - value expected -9199999999444444444",13,10,0
  SzQTest2       db "QWTest 2 - value expected -9087654321987654321",13,10,0
  SzQTest3       db "QWTest 3 - value expected -1000000000999999999",13,10,0
  SzQTest4       db "QWTest 4 - value expected -999999444444444",13,10,0
  SzQTest5       db "QWTest 5 - value expected -555555123456789",13,10,0
  SzQTest6       db "QWTest 6 - value expected -100000999999999",13,10,0

  SzDTest1       db "Test 1 - value expected -1444444444",13,10,0
  SzDTest2       db "Test 2 - value expected -1234567890",13,10,0
  SzDTest3       db "Test 3 - value expected -1999999999",13,10,0
  SzDTest4       db "Test 4 - value expected -44444",13,10,0
  SzDTest5       db "Test 5 - value expected -12345",13,10,0
  SzDTest6       db "Test 6 - value expected -99999",13,10,0
  SzDTest7       db "Test 7 - value expected -1",13,10,0


.data?

align 4

  szBuffer      BYTE  32 dup (?)


.code

Start:
	Invoke	Main
	Invoke	ExitProcess, 0


Main    proc

        push    ebx
        mov     eax, input("Please terminate any high-priority tasks and press ENTER to begin...")
        print   chr$(13,10,13,10,"QWORD to ASCII tests:",13,10,13,10)


        print   addr SzQTest1

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sqwTest1
        mov     edx, DWORD PTR (sqwTest1+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sqwTest1
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzCRT
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  i64toa, sqwTest1, addr szBuffer
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQTest2

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sqwTest2
        mov     edx, DWORD PTR (sqwTest2+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sqwTest2
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzCRT
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  i64toa, sqwTest2, addr szBuffer
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQTest3

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sqwTest3
        mov     edx, DWORD PTR (sqwTest3+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sqwTest3
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzCRT
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  i64toa, sqwTest3, addr szBuffer
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQTest4

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sqwTest4
        mov     edx, DWORD PTR (sqwTest4+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sqwTest4
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzCRT
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  i64toa, sqwTest4, addr szBuffer
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQTest5

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sqwTest5
        mov     edx, DWORD PTR (sqwTest5+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sqwTest5
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzCRT
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  i64toa, sqwTest5, addr szBuffer
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzQTest6

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sqwTest6
        mov     edx, DWORD PTR (sqwTest6+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sqwTest6
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzCRT
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  i64toa, sqwTest6, addr szBuffer
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   chr$(13,10,13,10,"DWORD to ASCII tests:",13,10,13,10)

 comment    * ------------------------------------------------------------
            Although we don't use it or check it, all 3 routines give the
            same output value in EAX, the number of chars written to the
            output string buffer (not counting the null-termination).
            ------------------------------------------------------------ *

        print   addr SzDTest1

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest1
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest1
        mov     edx, DWORD PTR (sdwTest1+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sdwTest1
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest2

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest2
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest2
        mov     edx, DWORD PTR (sdwTest2+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sdwTest2
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest3

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest3
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest3
        mov     edx, DWORD PTR (sdwTest3+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sdwTest3
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest4

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest4
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest4
        mov     edx, DWORD PTR (sdwTest4+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sdwTest4
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest5

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest5
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest5
        mov     edx, DWORD PTR (sdwTest5+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sdwTest5
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest6

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest6
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest6
        mov     edx, DWORD PTR (sdwTest6+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sdwTest6
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        print   addr SzDTest7

        print   addr SzWS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest7
        invoke  DW2A
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzIB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, DWORD PTR sdwTest7
        mov     edx, DWORD PTR (sdwTest7+4)
        invoke  QWtoASCII
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzRF
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  qwtoa,ADDR sdwTest7
        counter_end
        mov     ebx, eax
        print   addr szBuffer
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        mov     eax, input(" Press ENTER to exit...")
        pop     ebx
        ret

Main	EndP

; ------------------------------------------------------------------------------

OPTION PROLOGUE:none
OPTION EPILOGUE:none

Align 16

DW2A    proc

    ; -------------------------------------------------------------
    ; "fixed" version of routine from MASM library
    ; return value in EAX should be number of chars written
    ; sadly there appears to be no option to convert a QWORD...
    ; -------------------------------------------------------------
    
    invoke wsprintf, ADDR szBuffer, ADDR fMtStrinG, eax
    ret

DW2A    endp

; ------------------------------------------------------------------------------

Align 16

QWtoASCII    proc

 comment    * ------------------------------------------------------------
            Convert positive QWORD to ASCII string (no sign) by IanB.

            On entry:
                EAX/EDX = value to convert Lo/Hi
            On exit:
                EAX = count of chars written
                ECX = pointer to null-termination byte in output string
                      in case we want to add more chars afterwards
                EDX = original pointer to string buffer
                string buffer contains the null-terminated ASCII string
            EBX/EBP/EDI/ESI preserved
            ------------------------------------------------------------ *

        lea     ecx, szBuffer
        push    ebx
        xor     ebx, ebx                    ; zero EBX
        push    esi
        push    edi
        push    ecx                         ; save pointer
        add     edx, ebx                    ; check for sign in top bit
        jns     @F

        not     eax
        not     edx
        add     eax, 1
        adc     edx, ebx
        mov     BYTE PTR [ecx], "-"
        add     ecx, 1
@@:
        mov     esi, edx                    ; hold good values in EDI/ESI
        mov     edi, eax
        mov     bl, "0"
        test    edx, edx                    ; can we skip the slow top DWORD stuff
        jz      TestLowDWORD

        mov     bh, bl                      ; keep for convenience
        cmp     esi, 2H
        jb      Digit09
        jz      Digit10a
        cmp     edx, 17H
        jb      Digit10
        jz      Digit11a
        cmp     esi, 0e8H
        jb      Digit11
        jz      Digit12a
        cmp     edx, 918H
        jb      Digit12
        jz      Digit13a
        cmp     esi, 5af3H
        jb      Digit13
        jz      Digit14a
        cmp     edx, 38d7eH
        jb      Digit14
        jz      Digit15a
        cmp     esi, 2386f2H
        jb      Digit15
        jz      Digit16a
        cmp     edx, 1634578H
        jb      Digit16
        jz      Digit17a
        cmp     esi, 0de0b6b3H
        jb      Digit17
        jz      Digit18a
        cmp     edx, 8ac72304H
        jb      Digit18
        ja      Digit19
        cmp     eax, 89e80000H
        jb      Digit18

Digit19:
        sub     eax, 89e80000H              ; 10,000,000,000,000,000,000
        sbb     edx, 8ac72304H
        add     bl, 1                       ; max value of 19th digit is 1
                                            ; so no need to loop
        mov     edi, eax                    ; copy good values
        mov     esi, edx
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit18

Digit18a:
        cmp     eax, 0a7640000H
        jb      Digit17

Digit18:
        sub     eax, 0a7640000H             ; 1,000,000,000,000,000,000
        sbb     edx, 0de0b6b3H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     Digit18
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit17

Digit17a:
        cmp     eax, 5d8a0000H
        jb      Digit16

Digit17:
        sub     eax, 5d8a0000H              ; 100,000,000,000,000,000
        sbb     edx, 1634578H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     Digit17
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit16

Digit16a:
        cmp     eax, 6fc10000H
        jb      Digit15

Digit16:
        sub     eax, 6fc10000H              ; 10,000,000,000,000,000
        sbb     edx, 2386f2H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     Digit16
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit15

Digit15a:
        cmp     eax, 0a4c68000H
        jb      Digit14

Digit15:
        sub     eax, 0a4c68000H             ; 1,000,000,000,000,000
        sbb     edx, 38d7eH
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     Digit15
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit14

Digit14a:
        cmp     eax, 107a4000H
        jb      Digit13

Digit14:
        sub     eax, 107a4000H              ; 100,000,000,000,000
        sbb     edx, 5af3H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     Digit14
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit13

Digit13a:
        cmp     eax, 4e72a000H
        jb      Digit12

Digit13:
        sub     eax, 4e72a000H              ; 10,000,000,000,000
        sbb     edx, 918H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     Digit13
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit12

Digit12a:
        cmp     eax, 0d4a51000H
        jb      Digit11

Digit12:
        sub     eax, 0d4a51000H             ; 1,000,000,000,000
        sbb     edx, 0e8H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     Digit12
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit11

Digit11a:
        cmp     eax, 4876e800H
        jb      Digit10

Digit11:
        sub     eax, 4876e800H              ; 100,000,000,000
        sbb     edx, 17H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     Digit11
@@:
        mov     eax, edi                    ; copy good values to test
        mov     edx, esi
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1
        jmp     Digit10

Digit10a:
        cmp     eax, 540be400H
        jb      Digit09

Digit10:
        sub     eax, 540be400H              ; 10,000,000,000
        sbb     edx, 2H
        jb      @F
        add     bl, 1
        mov     edi, eax                    ; save good values
        mov     esi, edx
        jmp     Digit10
@@:
        mov     eax, edi                    ; copy good values to test
        mov     [ecx], bl
        mov     bl, bh
        add     ecx, 1

Digit09:
        mov     edx, 1                      ; convenience number
@@:
        sub     eax, 1000000000
        sbb     esi, 0
        jb      @F
        add     bl, dl
        mov     edi, eax                    ; save good value
        jmp     @B

TestLowDWORD:
        mov     edx, 1                      ; convenience number
        cmp     eax, 10
        jb      Digit00
        cmp     edi, 100
        jb      Digit01
        cmp     eax, 1000
        jb      Digit02
        cmp     edi, 10000
        jb      Digit03
        cmp     eax, 100000
        jb      Digit04
        cmp     edi, 1000000
        jb      Digit05
        cmp     eax, 10000000
        jb      Digit06
        cmp     edi, 100000000
        jb      Digit07
        sub     eax, 1000000000
        jb      Digit08

Digit09a:
        mov     edi, eax                    ; save good value, no high DWORD
        add     bl, dl
        sub     eax, 1000000000             ; only 3 iterations of this loop max
        jae     Digit09a
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit08:
        mov     eax, (-900000000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop08
@@:
        sub     esi, 100000000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 100000000
        mov     edi, esi                    ; save good value
        js      @B

FromTop08:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit07:
        mov     eax, (-90000000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop07
@@:
        sub     esi, 10000000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 10000000
        mov     edi, esi                    ; save good value
        js      @B

FromTop07:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit06:
        mov     eax, (-9000000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop06
@@:
        sub     esi, 1000000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 1000000
        mov     edi, esi                    ; save good value
        js      @B

FromTop06:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit05:
        mov     eax, (-900000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop05
@@:
        sub     esi, 100000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 100000
        mov     edi, esi                    ; save good value
        js      @B

FromTop05:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit04:
        mov     eax, (-90000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop04
@@:
        sub     esi, 10000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 10000
        mov     edi, esi                    ; save good value
        js      @B

FromTop04:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit03:
        mov     eax, (-9000)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop03
@@:
        sub     esi, 1000
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 1000
        mov     edi, esi                    ; save good value
        js      @B

FromTop03:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit02:
        mov     eax, (-900)
        mov     esi, edi                    ; copy good value to test
        mov     bl, "0"
        mov     bh, "9"
        add     eax, edi                    ; check if digit = 9
        jns     FromTop02
@@:
        sub     esi, 100
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     eax, 100
        mov     edi, esi                    ; save good value
        js      @B

FromTop02:
        mov     bl, bh
        mov     edi, eax
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit01:
        mov     esi, (-90)
        mov     bl, "0"
        mov     bh, "9"
        add     esi, edi                    ; check if digit = 9
        jns     FromTop01
@@:
        mov     eax, edi                    ; save good value
        sub     edi, 10
        jb      @F
        add     bl, dl
        sub     bh, dl
        add     esi, 10
        js      @B

FromTop01:
        mov     bl, bh
        mov     eax, esi                    ; copy good final digit
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit00:
        add     al, "0"
        mov     ebx, edx                    ; EBX = 1
        pop     edx                         ; retrieve original string pointer
        mov     [ecx], ax                   ; add null-termination
        add     ecx, ebx                    ; point to null-termination byte
        pop     edi
        mov     eax, ecx
        pop     esi
        sub     eax, edx                    ; get count of chars written
        pop     ebx
        ret

QWtoASCII endp

; ------------------------------------------------------------------------------

OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

; #########################################################################
;
;                             qwtoa
;
; Procedure for converting a 64-bit signed integer from memory to ASCII
;
; Limitation: The st5, st6 and st7 registers on the FPU will be trashed
;
; Return: EAX!=0 and null-terminated ASCII string in memory
;         EAX =0 if FPU unusable and null string in memory
;
; Usage:  invoke qwtoa,lpQW,lpBuf
;
;   where:  
;   lpQW  = pointer to the location of the qword in memory
;   lpBuf = pointer to a memory buffer for the null-terminated ASCII
;           string (a 21-byte buffer is sufficient)
;
; All CPU registers except EAX are preserved
;
;                       by Raymond Filiatreault
;                              May 2005
;                            MASM  syntax
;
; Algorithm:
; The range of a signed qword is +/-9223372036854775807 which has up to
; 19 digits. By dividing by 10, the quotient would then have a maximum of
; only 18 digits which can then be handled with the FBSTP instruction. The
; single-digit remainder of the division is later converted to ASCII and
; appended to the string converted from the stored packed BCD of the quotient.
;
; #########################################################################

;      .386                   ; minimum processor needed for 32 bit
;      .model flat, stdcall   ; FLAT memory model & STDCALL calling
;      option casemap :none   ; set code to case sensitive

; #########################################################################

Align 16

qwtoa proc USES ecx esi edi lpQW:DWORD

LOCAL tempBCD     :TBYTE
LOCAL oldCW       :WORD
LOCAL newCW       :WORD

      fclex                   ;clear exception flags
      ffree st(7)
      ffree st(6)
      ffree st(5)             ;3 FPU registers required

      fstcw oldCW
      mov   ax,oldCW
      or    ah,03h            ;modify Control Word for maximum precision
      mov   newCW,ax
      fldcw newCW             ;load modified Control Word

      mov   eax,lpQW          ;retrieve address of qword
      fild  qword ptr[eax]    ;load the qword on the FPU
      fld   st                ;copy qword
      mov   eax,10
      push  eax
      fidiv dword ptr[esp]

; The quotient must be truncated to an integer before storing as a packed BCD

      or    newCW,0C00h       ;modify Control Word for truncating
      fldcw newCW             ;load modified Control Word
      frndint                 ;truncate quotient to an integer

      fld   st                ;copy truncated quotient
      fbstp tempBCD           ;store quotient
      fimul dword ptr[esp]    ;multiply it by 10
      fsub                    ;subtract it from original qword
      fabs
      fistp dword ptr[esp]    ;store last digit on the stack and clean FPU
      fldcw oldCW             ;restore original Control Word

      fstsw ax                ;to check for exception flags
      fwait
      shr   al,1              ;check for FPU Invalid operation
      jnc   @F                ;continue if none

      pop   eax               ;clean stack
      xor   eax,eax
      lea   edi, szBuffer
      mov   [edi],al
      ret                     ;return with error code and null string

; Convert packed BCD to ASCII

   @@:
      lea   esi,tempBCD+9     ;point to most significant byte
      lea   edi, szBuffer
      mov   ecx,9
      mov   al,[esi]
      shl   al,1              ;move sign bit to CF
      jnc   @F
      mov   al,"-"
      stosb

; Find first non-zero digit

   @@:
      dec   esi
      cmp   byte ptr[esi],0
      jnz   @F
      dec   ecx
      jnz   @B
      jmp   lastdigit
   @@:
      mov   al,[esi]
      test  al,0F0h           ;check high nibble of 1st non-zero byte
      jz    lownibble

   @@:
      mov   al,[esi]
      push  eax
      shr   al,4              ;shift high nibble to low nibble
      add   al,30h            ;convert it to ASCII
      stosb                   ;store it in string
      pop   eax
      and   al,0Fh            ;keep only low nibble
lownibble:
      add   al,30h
      stosb
      dec   esi
      dec   ecx
      jnz   @B

lastdigit:
      pop   eax               ;retrieve least significant digit of qword
      add   al,30h
      stosw                   ;store it with a terminating 0
      ret

qwtoa endp

i64toa proc qw:QWORD, lpBuf:DWORD      
      invoke crt__i64toa, qw, lpBuf, 10
      ret
i64toa endp

End Start
